#!/usr/bin/env python

class C:
    def f(self):
        return 1

class D:
    def f(self):
        return 2

    def g(self):
        return 3

def test_one(obj):
    obj.f()
    return obj.g()

def test_neither(obj, obj2):
    if obj.f():
        obj = obj2
        obj.g()
    return 2

def test_either(obj, obj2):
    if obj:
        obj = obj2
        obj.g()
    return obj.f()

def test_neither2(obj, obj2):
    if obj:
        obj.g()
    else:
        obj.f()
    return 4

c = C()
d = D()
result1_3 = test_one(d)
result1_2 = test_neither(c, d)
result2_2 = test_either(c, d)
result1_4 = test_neither2(c, d)

# vim: tabstop=4 expandtab shiftwidth=4
